#!/usr/local/bin/perl

$passwordfile = "password.file";               #Password file name
$surveyadmin = "epperson\@colorado.edu";       #Admin for survey system

##############################################################
# Get input from HTML form and parse into name/value pairs.

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
        ($name, $value) = split(/=/, $pair);
        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
        $FORM{$name} = $value;
}

##############################################################
# Writes password file into associative array

open(PASS,"$passwordfile") ||
die "Sorry, I could not create /tmp/dataplace\n";
while (<PASS>) {
        ($password,$remainder) = split(/:/,$_,2);  #splits into password and everyth$
        $password =~ tr/A-Z/a-z/;                  #changes all letters to lowercase
        $stuff{$password} = $remainder;
        }
close PASS;

##############################################################
# Writes additional password fields to associative array based
# on password (the key) entered from previous form.

$passfound = "false";
$dontcheck = "false";
if ($FORM{i_pass} eq "--password used--") {
	$dontcheck = "true";
}

$password = $FORM{i_pass};
($i_name,$i_survey,$i_numquest,$i_owner) = split(/:/,$stuff{$password});

##############################################################
#Checks to see if field was populated and thus password exists

if ($dontcheck eq "false") {
	if ($i_survey eq "") {
		$passfound = "false";
		} else {
		$passfound = "true";
	}
}

############################################################## 
# Depending on password flag this will display the survey or
# a password invalid screen

print "Content-type: text/html\n\n";
if ($passfound eq "false") {
	print "<HTML>\n";  
	print "<HEAD>\n"; 
	print "<TITLE>Password Invalid</TITLE>\n"; 
	print "</HEAD>\n"; 
	print "<BODY BGCOLOR=\"#FFFFFF\">\n"; 
	print "<HR>\n"; 
	print "<P>\n"; 
	print "<CENTER><H1>Password Invalid</H1></CENTER>\n"; 
	print "<P>\n"; 
	print "<HR>\n"; 
	print "<P>\n"; 
	print "<CENTER>\n"; 
	print "If you feel you have incorrectly entered your password please try \n"; 
	print "<A HREF=\"./Home.html\">again</A>.\n"; 
	print "</CENTER>\n"; 
	print "<P>\n";
	print "<CENTER>\n"; 
	print "If you feel there is a problem with your password please mail the \n"; 
	print "<A HREF=\"mailto:$surveyadmin\">survey administrator</A>.\n"; 
	print "</CENTER>\n"; 
	print "<P>\n"; 
	print "<HR>\n"; 
	print "</BODY>\n"; 
	print "</HTML>\n"; 
	} else {

##############################################################
# This creates the html survey page.  The header is partially created here
# because the hidden fields will not populate if read in like the rest of
# the survey file is.  The remainder of the html survey file is read in.

	print "<!--Survey Header-->\n";
	print "<HTML><HEAD><TITLE>Automated Survey System</TITLE>\n";
	print "</HEAD><BODY BGCOLOR=\"#FFFFFF\">\n";
	print "<FORM ACTION=\"submit.cgi\" METHOD=\"POST\">\n";
	print "<INPUT TYPE=\"hidden\" NAME=\"i_survey\" VALUE=\"$i_survey\">\n";
	print "<INPUT TYPE=\"hidden\" NAME=\"i_name\" VALUE=\"$i_name\">\n";
	print "<INPUT TYPE=\"hidden\" NAME=\"i_surveyowner\" VALUE=\"$i_owner\">\n";
	print "<INPUT TYPE=\"hidden\" NAME=\"i_questions\" VALUE=\"$i_numquest\">\n";
        print "<INPUT TYPE=\"hidden\" NAME=\"i_pass\" VALUE=\"$FORM{i_pass}\">\n";
        print "<INPUT TYPE=\"hidden\" NAME=\"passwordfile\" VALUE=\"$passwordfile\">\n";

	open(SURVEY,"./data/$i_survey.srv") ||
	die "Sorry, I could not create /tmp/dataplace\n";
	while (<SURVEY>) {
	        chop;
	        print "$_\n";
	}
	close(SURVEY);
}







